//
//  MSFilterViewConstructor.h
//  DrawIt
//
//  Created by Pieter Omvlee on 11/29/07.
//  Copyright 2007 GetDrawIt. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Chocolat/Chocolat.h>

#import "MSFilter.h"

#import "MSColorWell.h"
#import "MSCheckBoxButtonCell.h"
#import "MSPopUpButtonCell.h"
#import "MSSliderCell.h"
#import "NSImage+BundleLoading.h"
#import "MSStepper.h"

@interface MSFilterViewConstructor : CHSingletonObject
{
  BOOL shouldIncludeCollapseArrow;
  BOOL shouldIncludeHideButton;
  BOOL shouldIncludeRemoveButton;
}
@property BOOL shouldIncludeCollapseArrow, shouldIncludeHideButton, shouldIncludeRemoveButton;
+ (id)constructViewForFilter:(MSFilter *)f target:(id)target width:(int)width;
+ (int)estimatedHeightOfFilter:(MSFilter *)f;

- (id)constructViewForFilter:(MSFilter *)f target:(id)target width:(int)width;
- (NSImage *)imageNamed:(NSString *)name;
- (int)estimatedHeightOfFilter:(MSFilter *)f;
@end

@interface MSFilterViewConstructor (Private)
- (void)createTitleForFilter:(MSFilter *)f inView:(NSView *)view;
- (void)createRemoveButtonForFilter:(MSFilter *)f target:(id)target inView:(NSView *)view;
- (void)createHideFilterButtonForFilter:(MSFilter *)f  target:(id)target inView:(NSView *)view;
- (void)createCollapseButtonForFilter:(MSFilter *)f  target:(id)target inView:(NSView *)view;
- (int)sliderControl:(NSDictionary *)defs view:(NSView *)view position:(int)top key:(NSString *)key filter:(MSFilter *)f value:(id)value;
- (int)colorControl:(NSDictionary *)defs  view:(NSView *)view position:(int)top key:(NSString *)key filter:(MSFilter *)f value:(id)value;
- (int)imageControl:(NSDictionary *)defs  view:(NSView *)view position:(int)top key:(NSString *)key filter:(MSFilter *)f value:(id)value;
- (int)optionControl:(NSDictionary *)defs view:(NSView *)view position:(int)top key:(NSString *)key filter:(MSFilter *)f value:(id)value options:(NSArray *)opts;
- (int)checkControl:(NSDictionary *)defs view:(NSView *)view position:(int)top key:(NSString *)key filter:(MSFilter *)f value:(id)value;
@end

@interface _NSMagnifier : NSObject {}
+ (id)sharedMagnifier;
- (void)trackMagnifierForPanel:(id)fp8;
@end

@interface NSTextField (Label)
- (id)initLabelWithFrame:(NSRect)frame;
@end
